# netilion-lab-tab-api

This is a python client to acccess [Netilion](https://netilion.endress.com/) REST API.

Swagger UI can be found at [Staging API](https://api.staging-env.netilion.endress.com/doc/v1/)  
IMPORTANT: this library is for Lab part of API!

Please visit our developer portal for further instructions and information: https://developer.netilion.endress.com/ 

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project.

## Requirements.

Python 3.4+

## Usage

```python
import netilion_lab_tab_api
from netilion_lab_tab_api.rest import ApiException

configuration = netilion_lab_tab_api.Configuration()
configuration.host = 'https://api.staging-env.iiot.endress.com/v1'

# FOR BASIC AUTH
configuration.api_key['API-Key'] = 'YOUR_BASIC_API_KEY'
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

# !OR!

# FOR OAUTH 2 PASSWORD GRANT
configuration.auth_type = netilion_lab_tab_api.AuthType.OAUTH_PASSWORD_GRANT
configuration.oauth_password_grant = netilion_lab_tab_api.OAuthPasswordGrant(username="YOUR_USERNAME",
                                                                     password="YOUR_PASSWORD",
                                                                     api_key="YOUR_OAUTH_API_KEY", # sometimes referred also as client id
                                                                     api_secret="YOUR_OAUTH_API_SECRET", # sometimes referred also as client secret
                                                                     oauth_token_url="https://api.staging-env.netilion.endress.com/oauth/token")

# create an instance of the API class
api_lab_instance_batch = netilion_lab_tab_api.BatchApi(netilion_lab_tab_api.ApiClient(configuration))

try:
    api_response = api_lab_instance_batch.get_batches();
    print(api_response)
except ApiException as e:
    print("Exception: %s\n" % e)

```